﻿-- Author      : Nogarder
-- Create Date : 2015/3/2 20:58:14
RS.CoolDown={}


local COMBATLOG_OBJECT_TYPE_PLAYER=COMBATLOG_OBJECT_TYPE_PLAYER
local bit_band=bit.band
local EventFilter={
	["SPELL_DAMAGE"]=1,
	["SPELL_MISSED"]=1,
	["SPELL_CAST_SUCCESS"]=1,
	["SPELL_AURA_REMOVED"]=1, 
}

local SpellCoolDownList={
	--[name]={
	--	[spellid]=cd length
}
local SpellCoolDownRegister={
	--[name]={
	--	[spellid]={
	--	 [frame]=true
}
local SpellCoolDown={
	--[name]={
	--	[spellid]=end time
}


RS.EventHandler.RegisterEvent(0,"COMBAT_LOG_EVENT_UNFILTERED","CoolDownMonitor",function(_,event,arg3,arg4,arg5,arg6,arg7,arg8,arg9,arg10,arg11,arg12,arg13,arg14,arg15,arg16,arg17,arg18,arg19,arg20,arg21,arg22,arg23,arg24,arg25)
	local nTime=GetTime() --don't use time stamp in combatlog,
	if(SpellCoolDownList[arg5] and --name check
		bit_band(arg6,COMBATLOG_OBJECT_TYPE_PLAYER)>0 and --is player
		EventFilter[event] and --good event
		SpellCoolDownList[arg5][arg12]--in spell list
		)then
			SpellCoolDown[arg5][arg12]=nTime+SpellCoolDownList[arg5][arg12]
	end
end)



RS.CoolDown.RegisterCoolDown=function(name,spellid,cooldown,frame,register)
	if(register)then
		if(not SpellCoolDownList[name])then
			SpellCoolDownList[name]={[spellid]=cooldown}
			SpellCoolDown[name]={[spellid]=0}
			SpellCoolDownRegister[name]={[spellid]={[frame]=true}}
		else
			SpellCoolDownList[name][spellid]=cooldown
			SpellCoolDown[name][spellid]=SpellCoolDown[name][spellid] or 0
			if(not SpellCoolDownRegister[name][spellid])then
				SpellCoolDownRegister[name][spellid]={[frame]=true}
			else
				SpellCoolDownRegister[name][spellid][frame]=true
			end
		end
	else
		if(SpellCoolDownRegister[name] and SpellCoolDownRegister[name][spellid])then
			SpellCoolDownRegister[name][spellid][frame]=nil
			if(not next(SpellCoolDownRegister[name][spellid]))then
				SpellCoolDownRegister[name][spellid]=nil
				SpellCoolDownList[name][spellid]=nil
				SpellCoolDown[name][spellid]=nil
			end
		end
	end
end

RS.CoolDown.GetCoolDown=function(name,spellid)
	if(SpellCoolDown[name])then
		return SpellCoolDown[name][spellid]
	end
	return nil
end