-- Author      : Nogarder
-- Create Date : 2015/3/2 4:42:06
local Tooltips=RS.Localization
--
local editbox=RS.Template.CreateEditBox(UIParent,200,20)
editbox:Hide()
editbox:SetFrameLevel(255)
editbox:SetFrameStrata("Tooltip")
editbox:SetPoint("CENTER",UIParent,"CENTER")
RS.Template.SetTooltips(Tooltips["EscToCancel"],editbox,nil,2)

RS.Template.CreateBackground(editbox,editbox,0,1,-10)

local label=RS.Template.CreateText(editbox,Tooltips["InputValue"])
label:SetPoint("BOTTOM",editbox,"TOP")
--
local button=RS.Template.CreateButton(editbox,20,20,"+")
button:SetPoint("LEFT",editbox,"RIGHT",1,0)
button:HookScript("OnMouseUp",function()
	RS.RunFunc(editbox.OnButtonClickedFunc,editbox:GetText())
end)
RS.Template.SetTooltips(Tooltips["+"],button)
--
local closer=RS.Template.SetCloser(editbox,nil,2)
closer:SetPoint("RIGHT",editbox,"LEFT",1,0)
--
editbox:SetScript("OnEnterPressed",function(self)
	RS.RunFunc(self.CallBackFunc,self:GetText())
	self:Hide()
end)
editbox:SetScript("OnCursorChanged",function(self)
	RS.RunFunc(self.OnValueUpdateFunc)
	end)
editbox:SetScript("OnEscapePressed",function(self)
	self:Hide()
end)
RS.Template.SetInputBox=function(parent,text,defaultvalue,onbuttonclickedfunc)
	editbox:ClearAllPoints()
	--
	editbox:Hide()
	label:SetText(text)
	--editbox:SetParent(parent)
	editbox:SetText(defaultvalue or nil)
	editbox.CallBackFunc=nil
	editbox.OnValueUpdateFunc=nil
	editbox.CallBackFunc=nil
	RS.Animation.ShowFrame(editbox)
	--
	if(onbuttonclickedfunc)then
		editbox.OnButtonClickedFunc=onbuttonclickedfunc
		button:Show()
	else
		button:Hide()
	end
	--
	editbox:SetFocus()
	return editbox
end
RS.Template.HideInputBox=function()
	editbox:Hide()
end
--
RS.RegisterTemplate(editbox,RS.Template.HideInputBox)
